using CloudBuilder.Core.Authorization;
using CloudBuilder.Core.DatabaseAccessor.Entity;
using System.ComponentModel.DataAnnotations;
using System.ComponentModel.DataAnnotations.Schema;
namespace CloudBuilder.AI.Entity
 {
    [TypeScript]
    [Table("book_dms_file")]
    public class BookDmsFileEntity : EntityBase<int>
    {

    public BookDmsFileEntity() 
    {
    }

    [Column("created_datetime")]
    public DateTime CreatedDatetime  { get; set; }
    [Column("created_by")]
    public string CreatedBy  { get; set; }
    [Column("updated_datetime")]
    public DateTime UpdatedDatetime  { get; set; }
    [Column("updated_by")]
    public string UpdatedBy  { get; set; }
    [Key]
    [Column("file_id")]
    public int FileId  { get; set; }
    [Column("upload_name")]
    public string UploadName  { get; set; }
    [Column("file_category")]
    public string FileCategory  { get; set; }
    [Column("org_file_name")]
    public string OrgFileName  { get; set; }

    public const string CREATED_DATETIME = "CreatedDatetime";
    public const string CREATED_BY = "CreatedBy";
    public const string UPDATED_DATETIME = "UpdatedDatetime";
    public const string UPDATED_BY = "UpdatedBy";
    public const string FILE_ID = "FileId";
    public const string UPLOAD_NAME = "UploadName";
    public const string FILE_CATEGORY = "FileCategory";
    public const string ORG_FILE_NAME = "OrgFileName";

    public const string DB_NAME_BOOK_DMS_FILE = "book_dms_file";
    public const string DB_NAME_FIELDS="created_datetime,created_by,updated_datetime,updated_by,file_id,upload_name,file_category,org_file_name";

    public const string DB_CREATED_DATETIME = "created_datetime";
    public const string DB_CREATED_BY = "created_by";
    public const string DB_UPDATED_DATETIME = "updated_datetime";
    public const string DB_UPDATED_BY = "updated_by";
    public const string DB_FILE_ID = "file_id";
    public const string DB_UPLOAD_NAME = "upload_name";
    public const string DB_FILE_CATEGORY = "file_category";
    public const string DB_ORG_FILE_NAME = "org_file_name";


    public static BookDmsFileEntity GetInstance()
    {
        return new BookDmsFileEntity();
    }

    public virtual void CopyFrom(BookDmsFileEntity source)
    {
        CopyFrom(source, true);
    }

    public virtual void CopyFrom(BookDmsFileEntity source, bool includeSystemFields)
    {
        if (source == null)
        {
            throw new NullReferenceException("Source entity is null.");
        }

        this.CreatedDatetime =  source.CreatedDatetime;
        this.CreatedBy =  source.CreatedBy;
        this.UpdatedDatetime =  source.UpdatedDatetime;
        this.UpdatedBy =  source.UpdatedBy;
        this.FileId =  source.FileId;
        this.UploadName =  source.UploadName;
        this.FileCategory =  source.FileCategory;
        this.OrgFileName =  source.OrgFileName;

        if (includeSystemFields)
        {
        this.CreatedDatetime =  source.CreatedDatetime;
        this.CreatedBy =  source.CreatedBy;
        this.UpdatedDatetime =  source.UpdatedDatetime;
        this.UpdatedBy =  source.UpdatedBy;
        }
    }

    public override string GetSelectFrom()
    {
        return $" select {DB_NAME_FIELDS} from { DB_NAME_BOOK_DMS_FILE}  with(nolock) ";
    }
	
    public override string GetSelectCountFrom(string sqlWhere)
    {
        return $" select count(*) from { DB_NAME_BOOK_DMS_FILE}  with(nolock) where 1=1 {sqlWhere}";
    }
	
    public override string GetSelectTopFrom(int limit, int start,string orderby,string orderbytag,  string sqlWhere)
    {
            if (string.IsNullOrEmpty(orderbytag)  || orderbytag.Trim() != "desc") orderbytag = "asc";
            if (string.IsNullOrEmpty(orderby) || !DB_NAME_FIELDS.Contains(orderby)) orderby =  DB_FILE_ID ;  		
		string top = limit > 0 ? $"top {limit}" : "";
        return $" select {top} {DB_NAME_FIELDS} from (select {DB_NAME_FIELDS}  ,row_number() over(order by {orderby} {orderbytag}) as num from { DB_NAME_BOOK_DMS_FILE}  with(nolock) where 1=1 {sqlWhere} ) a where num> {limit * (start - 1)}";
    }

    public BookDmsFileEntity Clone()
    {
        BookDmsFileEntity result = new BookDmsFileEntity();
        result.CopyFrom(this);

        return result;
    }

    }
}
